from sys import argv
from pathlib import Path

name = input('Please enter funk name: ') if len(argv) < 2 else argv[1]

if not name:
  raise ValueError('Must supply a name for the funk.')

if name.endswith('.py'):
  name -= '.py'

path = './src/funks/' + f'{name}'.replace('.', '/') + '.py'

# Ensure directory exists before writing file
directory = path[:path.rfind('/')]
Path(directory).mkdir(parents=True, exist_ok=True)

with open(path, 'w') as φ:
  φ.writelines(
    '\n'.join([
      "from funki.funk import Funk",
      "",
      "# def _run(σ, x):",
      "#   # Reminders:",
      "#   # * write test first.",
      "#   # * σ: dict that holds state configured in setup method",
      "#   # * x: dict of input values",
      "#   pass",
      "",
      "# def _setup():",
      "#   # Sets state of σ by returning a dict that gets blended with σ.",
      "#   # This method runs when testing prior to execution of run,",
      "#   # so it can be used to make changes to the environment as well",
      "#   # e.g. creating a file or directory necessary for run to execute.",
      "#   return {'logged_in': True}",
      "",
      "# def _tear_down(σ):",
      "#   # This function runs after run when testing, and so can be used to",
      "#   # repair any changes made by either setup, or run.",
      "#   # Or, alternatively closing a connection with a database or",
      "#   # external resource.",
      "#   pass",
      "",
      "funk = Funk(",
      "  enabled=False,",
      f"  name='{name}',",
      f"  description='',",
      "  io_value_pairs=[",
      "    ({'x': ''},{'y': ''}),",
      "    (",
      "      {'x': ''},",
      "      {'y': ''}",
      "    )",
      "  ],",
      "  # output_properties=[",
      "  #  output_property_funk_0,",
      "  #  output_property_funk_1,",
      "  #],",
      "  # run=_run",
      "  # run=lambda σ, x: None",
      "  # setup=_setup",
      "  # setup=lambda σ, x: None",
      "  # tear_down=_tear_down",
      "  # tear_down=lambda σ, x: None",
      ")",
      "",
      "# Note all commented code including this line can be cleaned from all",
      "#  funks using the command: python3 -m funki.clean_funks",
    ])
  )
